<?php
if(!empty($_GET['redirect_url'])){
   youtube_auto_post_redirect_url();
}
function youtube_auto_post_redirect_url(){
    require_once ABSPATH. '/wp-load.php';
    /**
     * OAUTH Configuration
     */ 
    $user_id = get_current_user_id();
    $oauthClientID = get_option('gl_client_id');
    $oauthClientSecret = get_option('gl_secret_key');
    $baseUri = admin_url('?page=youtube-auto-post-menu');
    $redirectUri = home_url('?redirect_url=autopost'); 
    define('OAUTH_CLIENT_ID',$oauthClientID);
    define('OAUTH_CLIENT_SECRET',$oauthClientSecret);
    define('REDIRECT_URI',$redirectUri);
    define('BASE_URI',$baseUri);
    /**
     * Include google client libraries
     */ 
    require_once(YOUTUBE_AUTO_POST_PLUGIN_PATH.'api-library/google/autoload.php');
    require_once(YOUTUBE_AUTO_POST_PLUGIN_PATH.'api-library/google/Client.php');
    require_once(YOUTUBE_AUTO_POST_PLUGIN_PATH.'api-library/google/Service/YouTube.php');
    $client = new Google_Client();
    $client->setClientId(OAUTH_CLIENT_ID);
    $client->setClientSecret(OAUTH_CLIENT_SECRET);
    $client->setScopes('https://www.googleapis.com/auth/youtube');
    $client->setRedirectUri(REDIRECT_URI);
    $client->setAccessType('offline');
    /**
     * Define an object that will be used to make all API requests.
     */ 
    $youtube = new Google_Service_YouTube($client); 
    $tokenSessionKey = 'token-' . $client->prepareScopes(); 
    $state = mt_rand(); 
    $client->setState($state);  
    update_option('youtube_upload_state', $state);
    if(isset($_GET['code'])) { 
        $state = get_option('youtube_upload_state', true);
        $client->authenticate($_GET['code']); 
        $accesstoken = $client->getAccessToken(); 
        $accesstoken = update_option('youtube_upload_accesstoken',$accesstoken);
    }
    $getaccesstoken = get_option('youtube_upload_accesstoken',true);
    if(isset($getaccesstoken)){ 
      $client->setAccessToken($getaccesstoken); 
      header("Location: $baseUri");
      die();
    }
} 