<?php
/**
 * Provide a public-facing view for the plugin
 *
 * This file is used to markup the public-facing aspects of the plugin.
 *
 * @link       https://https://codecanyon.net/search/kamleshyadav
 * @since      1.0.0
 *
 * @package    Youtube_Auto_Post
 * @subpackage Youtube_Auto_Post/public/partials
 */
?>
<div class="ap-post-form-wrapper">
    <div id="ap-response-massage"></div>
    <form id="login" action="login" method="post">
        <h4 class="ap-form-title"><?php echo esc_html__('Login','youtube-auto-post'); ?></h4>
        <p class="status"></p>
        <div class="ap-form-group">
         <label for="user_name"><?php echo esc_html__('Username','youtube-auto-post'); ?></label>
         <input id="user_name" type="text" name="user_name" value="">
        </div>
        <div class="ap-form-group">
            <label for="user_password"><?php echo esc_html__('Password','youtube-auto-post'); ?></label>
            <input id="user_password" type="password" name="user_password" value="">
        </div>
        <div class="ap-form-group">
          <a class="lost" href="<?php echo wp_lostpassword_url(); ?>"><?php echo esc_html__('Lost Your Password?','youtube-auto-post'); ?></a>
        </div>
        <div class="ap-form-group">
          <button type="submit" class="submit_button ap-btn" name="submit">
          <?php echo esc_attr__('Login','youtube-auto-post'); ?></button>
        </div>
        <?php wp_nonce_field( 'ajax-login-nonce', 'security' ); ?>
    </form>
</div>